class Hash #:nodoc: all

  # Same as Hash#merge but recursively merges sub-hashes.
  # different from deep_merge because it does not overwrite Hash leaves with values

  def recursive_merge(other)
    hash = self.dup
    other.each do |key, value|
      myval = self[key]

      if myval.is_a?(Hash)
        hash[key] = myval.recursive_merge(value) if value.is_a?(Hash)
      else
        hash[key] = value
      end
    end
    hash
  end

  # Same as Hash#merge! but recursively merges sub-hashes.

  def recursive_merge!(other)
    other.each do |key, value|
      myval = self[key]

      if myval.is_a?(Hash)
        myval.recursive_merge!(value) if value.is_a?(Hash)
      else
        self[key] = value
      end
    end
    self
  end
end

