##
#
# @example
#   help <<-EOS.undent
#     Here my help usage
#      sample_code
#
#     Fix
#   EOS
#   puts help.red.bold
#
class String
  def self.colors
    @_colors ||= {
      :black   => 30,
      :red     => 31,
      :green   => 32,
      :yellow  => 33,
      :blue    => 34,
      :magenta => 35,
      :cyan    => 36,
      :white   => 37
    }
  end

  def self.variations
    @_variations ||= {
      :clear   => 0,
      :bold    => 1,
    }
  end

  variations.each do |variation, value|
    define_method(variation) do
      ["\e[", value.to_s, "m", self, "\e[", self.class.variations[:clear], "m"] * ''
    end
  end

  colors.each do |color, value|
    define_method(color) do
      ["\e[", value.to_s, "m", self, "\e[", self.class.variations[:clear], "m"] * ''
    end

    define_method("bright_#{color}") do
      ["\e[1;",value.to_s, "m", self, "\e[", self.class.variations[:clear], "m"] * ''
    end

  end

  def important!
    bold.red
  end

  def unansi
    gsub(/\e\[[0-9;]*m/, '')
  end

end